/*
 * virsh-exec.h: client for execution commands in guest thru GA
 *
 * Copyright (C) 2020 Parallels International GmbH
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <virsh.h>

int virshExec(vshControl *ctl,
              virDomainPtr dom,
              const char *cmd,
              const char **args,
              unsigned int nargs,
              const char **envs,
              unsigned int nenvs,
              virTypedParameterPtr params,
              int nparams,
              unsigned int flags);

void virshExecDisconnect(void);
